clear;
clc;

%FILENAME = 'hall1.pgm';
FILENAME = 'ambassadors-skull.pgm';
%DATAFILE = 'hall1.dat';
DATAFILE = 'ambassadors-skull.dat';
DATA = load(DATAFILE);

image_coord = DATA(1:4, :);
real_coord = DATA(5:8, :);

area_image = poly_area(image_coord, 4);

[centroid_imagex, centroid_imagey] = centroid_poly(image_coord, 4, area_image);

disp(['Image area: ', num2str(area_image)])
disp(['Image centriod: ', num2str(centroid_imagex), ', ', num2str(centroid_imagey)])

new_image(:, 1) = image_coord(:, 1) - centroid_imagex;
new_image(:, 2) = image_coord(:, 2) - centroid_imagey;

avg_distance = mean(sqrt(new_image(:, 1).*new_image(:, 1) + new_image(:, 2).*new_image(:, 2)))
new_image = new_image ./ avg_distance

T = (1 / avg_distance) * [1 0 -centroid_imagex; 0 1 -centroid_imagey; 0 0 avg_distance]

area_world = poly_area(real_coord, 4);
[centroid_worldx, centroid_worldy] = centroid_poly(real_coord, 4, area_world);

disp(['World area: ', num2str(area_world)])
disp(['World centriod: ', num2str(centroid_worldx), ', ', num2str(centroid_worldy)])

new_world(:, 1) = real_coord(:, 1) - centroid_worldx;
new_world(:, 2) = real_coord(:, 2) - centroid_worldy;

avg_distance2 = mean(sqrt(new_world(:, 1).*new_world(:, 1) + new_world(:, 2).*new_world(:, 2) + 1))
new_world = new_world ./ avg_distance2

UT = (1 / avg_distance2) * [1 0 -centroid_worldx; 0 1 -centroid_worldy; 0 0 avg_distance2]

A = [new_world(1, 1) new_world(1, 2) 1 0 0 0 -new_image(1, 1)*new_world(1, 1) -new_image(1, 1)*new_world(1, 2) -new_image(1, 1);
    0 0 0 new_world(1, 1) new_world(1, 2) 1 -new_image(1, 2)*new_world(1, 1) -new_image(1, 2)*new_world(1, 2) -new_image(1, 2);
    new_world(2, 1) new_world(2, 2) 1 0 0 0 -new_image(2, 1)*new_world(2, 1) -new_image(2, 1)*new_world(2, 2) -new_image(2, 1);
    0 0 0 new_world(2, 1) new_world(2, 2) 1 -new_image(2, 2)*new_world(2, 1) -new_image(2, 2)*new_world(2, 2) -new_image(2, 2);
    new_world(3, 1) new_world(3, 2) 1 0 0 0 -new_image(3, 1)*new_world(3, 1) -new_image(3, 1)*new_world(3, 2) -new_image(3, 1);
    0 0 0 new_world(3, 1) new_world(3, 2) 1 -new_image(3, 2)*new_world(3, 1) -new_image(3, 2)*new_world(3, 2) -new_image(3, 2);
    new_world(4, 1) new_world(4, 2) 1 0 0 0 -new_image(4, 1)*new_world(4, 1) -new_image(4, 1)*new_world(4, 2) -new_image(4, 1);
    0 0 0 new_world(4, 1) new_world(4, 2) 1 -new_image(4, 2)*new_world(4, 1) -new_image(4, 2)*new_world(4, 2) -new_image(4, 2)];

[U, S, V] = svd(A);
h = V(:, size(V, 2));

H = [ h(1) h(2) h(3);
    h(4) h(5) h(6);
    h(7) h(8) h(9)];

disp('Input: image coordinates (bottom left to bottom right)')
new_image
disp('Input: assumed world coordinates (bottom left to bottom right)')
new_world

disp('Projective Matrix H:');
H

dnH = inv(T)*H*UT;

disp('Denormalized Projective Matrix H:');
dnH

disp(['Loading image:', FILENAME]);
imfinfo(FILENAME)
IM = imread(FILENAME, 'PGM');
disp('Image loaded.');

disp('Applying transform');
new_image = apply_transform(inv(dnH), IM);

figure(2)
image(gstocolor(new_image))
title('Transformed Image');
axis off
