clear
clc

%FILENAME = 'Checkers.bmp';
FILENAME = 'RailRoad.bmp';
%FILEDATA = 'Checkers.dat';
FILEDATA = 'RailRoad.dat';

DATA = load(FILEDATA);

% LS1_L1(1, :)=[123,425];
% LS1_L1(2, :)=[415,290];

% L11(3,:)=[319,334,1]-[w/2,h/2,0];
% L11(4,:)=[358,317,1]-[w/2,h/2,0];
% L11(5,:)=[415,290,1]-[w/2,h/2,0];

% LS1_L2(1, :)=[320,425];
% LS1_L2(2, :)=[512,290];

% L12(3,:)=[418,357,1]-[w/2,h/2,0];
% L12(4,:)=[449,334,1]-[w/2,h/2,0];
% L12(5,:)=[512,290,1]-[w/2,h/2,0];

% LS2_L1(1, :)=[123,425];
% LS2_L1(2, :)=[224,289];

% L21(3,:)=[173,357,1]-[w/2,h/2,0];
% L21(4,:)=[190,334,1]-[w/2,h/2,0];
% L21(5,:)=[224,289,1]-[w/2,h/2,0];

% LS2_L2(1, :)=[478,476];
% LS2_L2(2, :)=[388,297];

% L22(3,:)=[418,357,1]-[w/2,h/2,0];
% L22(4,:)=[402,325,1]-[w/2,h/2,0];
% L22(5,:)=[388,297,1]-[w/2,h/2,0];

LS1_L1 = DATA(1:2,:);
LS1_L2 = DATA(3:4,:);
LS2_L1 = DATA(5:6,:);
LS2_L2 = DATA(7:8,:);

% LS1_L1 = [96, 381;
%           232, 333];
% LS1_L2 = [386, 424;
%           513, 316];
%
% LS2_L1 = [221, 356;
%           319, 423];
% LS2_L2 = [575, 289;
%           484, 271];

% Line set 1
% L11m = (LS1_L1(1, 1) - LS1_L1(2, 1)) / (LS1_L1(1, 2) - LS1_L1(2, 2));
% L11b = LS1_L1(1, 1) - L11m*LS1_L1(1, 2);
% 
% L12m = (LS1_L2(1, 1) - LS1_L2(2, 1)) / (LS1_L2(1, 2) - LS1_L2(2, 2));
% L12b = LS1_L2(1, 1) - L12m*LS1_L2(1, 2);
% 
% A1 = [-L11m  1; -L12m  1];
% b1 = [L11b;L12b];
% X1 = linsolve(A1, b1)

X1 = vanish_points([LS1_L1;LS1_L2]);
X1 = X1 ./ X1(3);
T = X1(1);
X1(1) = X1(2);
X1(2) = T;

% Line set 2
% L21m = (LS2_L1(1, 1) - LS2_L1(2, 1)) / (LS2_L1(1, 2) - LS2_L1(2, 2));
% L21b = LS2_L1(1, 1) - L21m*LS2_L1(1, 2);
% 
% L22m = (LS2_L2(1, 1) - LS2_L2(2, 1)) / (LS2_L2(1, 2) - LS2_L2(2, 2));
% L22b = LS2_L2(1, 1) - L22m*LS2_L2(1, 2);
% 
% A2 = [-L21m  1; -L22m  1];
% b2 = [L21b;L22b];
% X2 = linsolve(A2, b2);

X2 = vanish_points([LS2_L1;LS2_L2]);
X2 = X2 ./ X2(3);
T = X2(1);
X2(1) = X2(2);
X2(2) = T;

% Vanishing Line

% VLm = (X1(1) - X2(1)) / (X1(2) - X2(2));
VLm = (X1(1) - X2(1)) / (X1(2) - X2(2));
VLlb = X1(1) - VLm*X1(2);

focal = 1;

VLa = VLm/VLlb;
VLb = 1/VLlb;
VLc = 1/focal;

Nlen = sqrt(VLa^2 + VLb^2 + VLc^2);
VLa = VLa / Nlen;
VLb = VLb / Nlen;
VLc = VLc / Nlen;

disp(['Equation of the Vanishing Line: ', num2str(VLa), ' x + ', num2str(VLb), ' y + ', num2str(VLc), ' = 0'])
a2b2 = (VLa*VLa) + (VLb*VLb);
E = (VLa*VLa*VLc + VLb*VLb) / a2b2;
F = (VLa*VLb*(VLc - 1)) / a2b2;
G = ((VLa*VLa) + (VLb*VLb*VLc)) / a2b2;

disp('Transform matrix:')
H = [E F VLa;
    F G VLb;
    -VLa -VLb VLc]

%  H = [1.0000    0.0000   -0.0002;
%     0.0000    1.0000    0.0052;
%     0.0002   -0.0052    1.0000]

disp(['Loading image:', FILENAME]);
imfinfo(FILENAME)
IM = imread(FILENAME, 'BMP');
disp('Image loaded.');
figure(1)
image(IM)
title('Original Image')
axis off

disp('Applying transform');
new_image = apply_transform_center(inv(H), IM);
%new_image = apply_transform(inv(H), IM);

figure(2)
image(new_image ./ 255)
title('Transformed Image');
axis off